function s = signal_overlapp_add(S, hop)
% Function performing an overlapp and and operation for reconstruction of a 
% signal after blockprocessing (via signal_blocking.m)
%
% IN: 
%	 S ... Matrix of segmented signal
%
% 	hop ... hopsize in Samples
%
% OUT:
%   s ... reconstructed signal.
%
% Authors: Franz Zotter, Ruediger Fasching, Johanna Kerber, Korbinian Wegler
% Date: 2018

N = size(S,1);
Ch = size(S,3);
Hops = size(S,2);
L = (Hops-1)*hop+N;
s = zeros(L,Ch);
idx = 1:N;

for h = 1:Hops
    s(idx+(h-1)*hop,:) = s(idx+(h-1)*hop,:)+...
        squeeze(S(:,h,:));
end